var Ci = Components.interfaces;
var Cc = Components.classes;

var sbasw = {
	init: function() {
		try { if(window.arguments[0]) window.opener=window.arguments[0]; } catch(e){}
		sbasw.prefs=Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.sbautosizer.");
		sbasw.sandbox=[[],[],[]];
		sbasw.mayChange=false;

		var min=sbasw.prefs.getIntPref('widthMin');
		var max=sbasw.prefs.getIntPref('widthMax');
		var off=sbasw.prefs.getIntPref('offsetText');
		document.getElementById('cleanOnSubmit').checked=sbasw.prefs.getBoolPref('cleanOnSubmit');
		document.getElementById('revertOnSubmit').checked=sbasw.prefs.getBoolPref('revertOnSubmit');
		document.getElementById('shrinkToButton').checked=sbasw.prefs.getBoolPref('shrinkToButton');

		// Load prefs
		if(max==off && max>0) {
			this.path=1; // Alternative
			sbasw.text2desc('altWidthPixels',sbasw.lang('widthAlt',max),false);
			sbasw.sandbox[1][0]=0; // Needs to be ==max for shrink2button
			sbasw.sandbox[1][1]=max;
			sbasw.sandbox[1][2]=max;
			// Guessing for fixed
			sbasw.sandbox[2][0]=max;
			sbasw.sandbox[2][1]=max;
			sbasw.sandbox[2][2]=off;
			// Guessing for normal
			sbasw.sandbox[0][1]=max;
			sbasw.sandbox[0][0]=0;
		} else if(min==max && min!=0) {
			this.path=2; // Fixed
			sbasw.text2desc('fixWidthPixels',sbasw.lang('widthFix',min),false);
			sbasw.sandbox[2][0]=min;
			sbasw.sandbox[2][1]=min;
			sbasw.sandbox[2][2]=off;
			// Guessing for alt
			sbasw.sandbox[1][0]=0;
			sbasw.sandbox[1][1]=min;
			sbasw.sandbox[1][2]=min;
			// Guessing for normal
			sbasw.sandbox[0][1]=min;
			sbasw.sandbox[0][0]=0;
		} else {
			this.path=0; // normal

			switch(min) {
				case 0:
					sbasw.text2desc('norMinWidthPixels',sbasw.lang('widthMinTitle',''),false);
					sbasw.sandbox[0][0]=0;
					break;
				case 1:
					sbasw.text2desc('norMinWidthPixels',sbasw.lang('widthMinSmall',''),false);
					sbasw.sandbox[0][0]=1;
					break;
				default:
					sbasw.text2desc('norMinWidthPixels',sbasw.lang('widthMinPx',min),false);
					sbasw.sandbox[0][0]=min;
			}
			sbasw.sandbox[0][0]+=off; // This prevents the jumping the first time

			if(max==0) {
				sbasw.text2desc('norMaxWidthPixels',sbasw.lang('widthMaxWide',''),false);
				sbasw.sandbox[0][1]=0;
			} else {
				sbasw.text2desc('norMaxWidthPixels',sbasw.lang('widthMaxPx',max),false);
				sbasw.sandbox[0][1]=max;
				// Guessing for alt
				sbasw.sandbox[1][0]=0;
				sbasw.sandbox[1][1]=max;
				sbasw.sandbox[1][2]=max;
				// Guessing for fixed
				sbasw.sandbox[2][0]=max;
				sbasw.sandbox[2][1]=max;
				sbasw.sandbox[2][2]=off;
			}
			sbasw.sandbox[2][2]=off;
		}

		document.getElementById('startBehaviour').selectedIndex=this.path;

		// Enable extra2 button manually
		var extra2=document.getElementById('sbautosizer-wizard').getButton('extra2');
		extra2.removeAttribute('hidden');
		extra2.setAttribute('onclick',"window.openDialog('chrome://sbautosizer/content/advanced.xul', '', 'chrome,titlebar,toolbar,centerscreen,dialog=no',window.opener);window.close();");
		extra2.label=sbasw.lang('buttonAdvanced','');
		extra2.setAttribute('accesskey',sbasw.lang('buttonAdvancedAccesskey',''));
	},

	lang: function(v,t) {
		return document.getElementById("locale").getFormattedString(v, [t+'']);
	},

	nextPageOnFirstPage: function() {
		nextItemVal=document.getElementById('startBehaviour').selectedItem.value;
		if(nextItemVal=='normal') newPage='norMinWidth';
		if(nextItemVal=='alternative') newPage='widthAlt';
		if(nextItemVal=='fixed') newPage='widthFix';
		document.getElementById('start').setAttribute('next',newPage);
	},

	canAdv: function(what) {
		document.getElementById('sbautosizer-wizard').canAdvance=what;
	},

	toggleSizing: function(what) { 
		sbasw.makeOnTop(what);
		sbasw.mayChange=what;

		if(what) {
			// Size searchbar according to page's text
			curPage=document.getElementById('sbautosizer-wizard').currentPage.pageid;
			var value='nosize';
			if(curPage=='widthAlt' && sbasw.sandbox[1][1]) value=sbasw.sandbox[1][1]+'';
			if(curPage=='widthFix' && sbasw.sandbox[2][1]) value=sbasw.sandbox[2][1]+'';
			if(curPage=='norMinWidth' && typeof sbasw.sandbox[0][0] != "undefined") {
				if(sbasw.sandbox[0][0]==0) value='label';
				else value=sbasw.sandbox[0][0];
			}
			if(curPage=='norMaxWidth' && sbasw.sandbox[0][1]) {
				if(sbasw.sandbox[0][1]==0) value='max';
				else value=sbasw.sandbox[0][1];
			}

			sbasw.prefs.setCharPref('manualResize',value);

			// Focus/Open Window
			var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
			sbasw.win = wm.getMostRecentWindow("navigator:browser");
			if(sbasw.win) sbasw.win.focus();
			else sbasw.win=window.openDialog("chrome://browser/content/", "_blank", "chrome,all,dialog=no");
			setTimeout("window.focus()",10);

		} else sbasw.prefs.setCharPref('manualResize','');

		try { sbasw.prefs.clearUserPref('tmp_WizardParams'); } catch(e) {};
		// Displaying the grippys is handled in sbautosizer.js/checkPrefs function.
		setTimeout('sbasw.registerPrevObserver('+what+');',0);
	},

	registerPrevObserver: function(what) {
		if(!sbasw.win || (sbasw.win && sbasw.win.sbautosizer.booted)) sbasw.DragNDropObserver(what);
		else setTimeout('sbasw.registerPrevObserver('+what+');',10);
	},

	DragNDropObserver: function(what) {
		if (!(sbasw.prefs instanceof Ci.nsIPrefBranchInternal)) return;
		if (what) {
			sbasw.prefObserver = new sbautosizerWizPrefObserver();
			sbasw.prefs.addObserver('', sbasw.prefObserver, false);
		} else if(sbasw.prefObserver) sbasw.prefs.removeObserver('',sbasw.prefObserver);
		sbasw.win=null;
	},

	text2desc: function(id,text,bold) {
		var d=document.getElementById(id);
		if(d.hasChildNodes())
			d.replaceChild(document.createTextNode(text),d.firstChild);
		else
			d.appendChild(document.createTextNode(text));
		d.removeAttribute("value"); // Strangely it seems to appear from nowhere?!
		if(bold) d.setAttribute("style","font-weight:bold;");
	},

	manualSizingChange: function() {
		if(!sbasw.mayChange) return;
		try {
			try { var newValue=sbasw.prefs.getCharPref('tmp_WizardParams'); } catch(e) { newValue=''; };
			newValue=newValue.split('|');
			if(newValue[0]==0 || newValue[0] == undefined) return;
			// width neededWidth tooltipwidth availableWidth focus?
			if(newValue[4]=='true') window.focus();
		} catch(e) { return; }
		sbasw.canAdv(true);

		var curPage=document.getElementById('sbautosizer-wizard').currentPage.pageid;
		switch(curPage) {
			case 'widthAlt':
				sbasw.text2desc('altWidthPixels',sbasw.lang('widthAltChange',newValue[0]),true);
				sbasw.sandbox[1][0]=0; //
				sbasw.sandbox[1][1]=newValue[0];
				sbasw.sandbox[1][2]=newValue[0];
			break;

			case 'widthFix':
				sbasw.text2desc('fixWidthPixels',sbasw.lang('widthFixChange',newValue[0]),true);
				sbasw.sandbox[2][0]=newValue[0];
				sbasw.sandbox[2][1]=newValue[0];
				sbasw.sandbox[2][2]=0;
			break;

			case 'norMinWidth':
				sbasw.sandbox[0][2]=0;
				if(newValue[0]<newValue[1]*1+5) {
					sbasw.text2desc('norMinWidthPixels',sbasw.lang('widthMinSmallChange',''),true);
					sbasw.sandbox[0][0]=1;
				} else if(newValue[0]<newValue[2]*1+15 && newValue[0]>newValue[2]*1-15) {
					sbasw.text2desc('norMinWidthPixels',sbasw.lang('widthMinTitleChange',''),true);
					sbasw.sandbox[0][0]=0;
				} else {
					sbasw.text2desc('norMinWidthPixels',sbasw.lang('widthMinPxChange',newValue[0]),true);
					sbasw.sandbox[0][0]=newValue[0];
				}
			break;

			case 'norMaxWidth':
				if(newValue[0]>newValue[3]*1-70) {
					sbasw.text2desc('norMaxWidthPixels',sbasw.lang('widthMaxWideChange',''),true);
					sbasw.sandbox[0][1]=0;
				} else {
					sbasw.text2desc('norMaxWidthPixels',sbasw.lang('widthMaxPxChange',newValue[0]),true);
					sbasw.sandbox[0][1]=newValue[0];
				}
			break;
		}
	},

	makeOnTop: function(what) {
		if(Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULRuntime).OS.toLowerCase()=='darwin') return;
		try { // Thanks to console2 extension :)
			var xulWin = window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShellTreeItem).treeOwner.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIXULWindow);
			xulWin.zLevel = (what) ? xulWin.highestZ : xulWin.normalZ;
		} catch(e) {}
	},

	savePrefs: function () {
		var p=document.getElementById('startBehaviour').selectedIndex;
		var intP1=["offsetLabel","offsetText","widthMax","widthMin","widthMin_Autocomplete_Popup"];
		var intP2=[1,sbasw.sandbox[p][2],sbasw.sandbox[p][1],sbasw.sandbox[p][0],200];
		for(p in intP1) sbasw.prefs.setIntPref(intP1[p], intP2[p]);

		var boolP=["cleanOnSubmit","revertOnSubmit","shrinkToButton" /*",useHelperTab" - currently no GUI! */]
		for(p in boolP) sbasw.prefs.setBoolPref(boolP[p], document.getElementById(boolP[p]).checked);

		if(document.getElementById('shrinkToButton').checked) {
			sbasw.prefs.setBoolPref("addButtonToToolbar", true);

			// In "enlarge on first strike" mode, it's useful to skip the middle step and enlarge immmediately:
			// (empty) Button, (focused but empty) small searchbar, (not empty) large searchbar
			// It behaves identical to "fixed width" in this case.
			if(this.path==1) sbasw.prefs.setIntPref(intP1[0], intP2[1]);
		}
		sbasw.cleanUp();
	},

	cleanUp: function() {
		sbasw.DragNDropObserver(false); // Force in case of cancel
		sbasw.toggleSizing(false);
		try { sbasw.prefs.clearUserPref('tmp_WizardParams'); } catch(e) {};
		try { sbasw.prefs.clearUserPref('manualResize'); } catch(e) {};
		try { window.opener.focus(); } catch(e) {};
	}
}

function sbautosizerWizPrefObserver() {
	sbasw.manualSizingChange();
}

sbautosizerWizPrefObserver.prototype = {
	observe: function(subject, topic, pref) {
		if (topic == 'nsPref:changed' && pref=='tmp_WizardParams') {
			try { sbasw.manualSizingChange(); } catch(e) {};
		}
	}
};
